// Copyright (c) 2015, Mikhail Stolyarov. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library do2template.repeat;

import 'dart:html';

class Do2Repeat {

  /// Клон элемента повторителя
  Element get html => _template.children.first.clone(true);

  Element _template = new DivElement();

  Element _parent;

  List<int> _hashTexts = new List();
  List<int> _hashElements = new List();

  Do2Repeat(Element element){
    _parent = element.parent;
    _template.children.add(element);
  }

  /// Добавляем текстовые данные [data] в повторитель
  void repeatText(List<Map<String,String>> data){
    data.forEach((Map<String,String> line){
      Element repeat = html;
      repeat.setAttribute('do2repeat-id', html.hashCode.toString());
      _hashTexts.add(repeat.hashCode);
      line.forEach((String key, String val){
        repeat.querySelectorAll('[do2repeat-field=$key]').forEach((Element element){
          element.appendText(val);
        });
      });
      _parent.children.add(repeat);
    });
  }

  /// Добавляем html элементы [data] в повторитель
  void repeatElement(List<Map<String,Element>> data){
    data.forEach((Map<String,Element> line){
      Element repeat = html;
      repeat.setAttribute('do2repeat-id', html.hashCode.toString());
      _hashElements.add(repeat.hashCode);
      line.forEach((String key, Element val){
        repeat.querySelectorAll('[do2repeat-field=$key]').forEach((Element element){
          element.append(val);
        });
      });
      _parent.children.add(repeat);
    });
  }

  /// Удаляем текстовые данные
  void eraserText(){
    _parent.children.removeWhere((Element element)=>_hashTexts.contains(element.hashCode));
    _hashTexts.clear();
  }

  /// Удаляем HTML элементы
  void eraserElement(){
    _parent.children.removeWhere((Element element)=>_hashElements.contains(element.hashCode));
    _hashElements.clear();
  }

  /// Удаляем все
  void eraserAll(){
    eraserText();
    eraserElement();
  }





}
